=== modified file 'msf_profile/__openerp__.py'
--- msf_profile/__openerp__.py	2011-10-10 17:42:46 +0000
+++ msf_profile/__openerp__.py	2011-11-08 16:37:31 +0000
@@ -75,6 +75,7 @@
         "threshold_value",
         "analytic_distribution_invoice",
 #        "analytic_distribution_purchase",
+        "out_step",
     ],
     "update_xml": [
         "report.xml",

=== added directory 'out_step'
=== added file 'out_step/__init__.py'
--- out_step/__init__.py	1970-01-01 00:00:00 +0000
+++ out_step/__init__.py	2011-11-08 16:37:31 +0000
@@ -0,0 +1,22 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import out_step
\ No newline at end of file

=== added file 'out_step/__openerp__.py'
--- out_step/__openerp__.py	1970-01-01 00:00:00 +0000
+++ out_step/__openerp__.py	2011-11-08 16:37:31 +0000
@@ -0,0 +1,38 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name" : "Delivered Out Step",
+    "version" : "0.1",
+    "author" : "MSF pam",
+    "category" : "Generic Modules/Inventory Control",
+    "description": """
+        Add a last step for out picking object corresponding to a confirmed Delivered status
+        """,
+    'website': 'http://www.unifield.org',
+    'init_xml': [],
+    "depends" : ["stock",],
+    'update_xml': ['out_step_view.xml',
+                   ],
+    "demo_xml": [],
+    'test': [#'test/msf_outgoing.yml'
+             ],
+    'installable': True,
+}

=== added file 'out_step/out_step.py'
--- out_step/out_step.py	1970-01-01 00:00:00 +0000
+++ out_step/out_step.py	2011-11-08 16:37:31 +0000
@@ -0,0 +1,44 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO Consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+from tools.translate import _
+import netsvc
+from datetime import datetime, timedelta
+from dateutil.relativedelta import relativedelta
+import decimal_precision as dp
+import netsvc
+import logging
+import tools
+from os import path
+
+class stock_picking(osv.osv):
+    '''
+    add a check boolean for confirmation of delivery
+    '''
+    _inherit = 'stock.picking'
+
+    _columns = {'delivered': fields.boolean(string='Delivered'),
+                }
+    _defaults = {'delivered': False,
+                 }
+     
+stock_picking()

=== added file 'out_step/out_step_view.xml'
--- out_step/out_step_view.xml	1970-01-01 00:00:00 +0000
+++ out_step/out_step_view.xml	2011-11-08 16:37:31 +0000
@@ -0,0 +1,22 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<openerp>
+    <data>
+    
+    	<record id="view_picking_out_form" model="ir.ui.view">
+            <field name="name">stock.picking.out.form</field>
+            <field name="model">stock.picking</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="stock.view_picking_out_form" />
+            <field name="arch" type="xml">
+            	<data>
+            	
+            		<field name="state" position="after">
+						<field name="delivered" />
+					</field>
+            	
+            	</data>
+            </field>
+		</record>
+    
+    </data>
+</openerp>

=== added directory 'out_step/test'
=== added file 'out_step/test/msf_outgoing.yml'
--- out_step/test/msf_outgoing.yml	1970-01-01 00:00:00 +0000
+++ out_step/test/msf_outgoing.yml	2011-11-08 16:37:31 +0000
@@ -0,0 +1,179 @@
+- 
+  Creating a res.partner record
+- 
+  !record {model: res.partner, id: res_partner_a0}:
+    credit_limit: 0.0
+    debit_limit: 0.0
+    name: A
+    supplier: true
+    
+- 
+  Creating a res.partner.address record
+- 
+  !record {model: res.partner.address, id: res_partner_address_0}:
+    partner_id: res_partner_a0
+    street: A
+    
+- 
+  Creating a res.partner record
+- 
+  !record {model: res.partner, id: res_partner_b0}:
+    credit_limit: 0.0
+    debit_limit: 0.0
+    name: B
+    supplier: true
+    
+    
+- 
+  Creating a res.partner.address record
+- 
+  !record {model: res.partner.address, id: res_partner_address_1}:
+    partner_id: res_partner_b0
+    street: B
+    
+-
+  I create product template .
+-
+  !record {model: product.template, id: product_template_p0}:
+    categ_id: product.cat0
+    cost_method: standard
+    mes_type: fixed
+    name: P
+    procure_method: make_to_stock
+    standard_price: 160.0
+    supply_method: buy
+    type: product
+    uom_id: product.product_uom_unit
+    uom_po_id: product.product_uom_unit
+    
+- 
+  Creating a product.product record
+- 
+  !record {model: product.product, id: product_product_p0}:
+    
+    standard_price: 1.0
+    valuation: manual_periodic
+    volume: 0.0
+    warranty: 0.0
+    weight: 0.0
+    weight_net: 0.0
+    product_tmpl_id: product_template_p0 
+    
+- 
+  Creating a sale.order record
+- 
+  !record {model: sale.order, id: sale_order_so0}:
+    amount_tax: 0.0
+    amount_total: 1.0
+    amount_untaxed: 1.0
+    company_id: base.main_company
+    date_order: '2011-04-13'
+    invoice_quantity: order
+    order_policy: manual
+    partner_id: res_partner_a0
+    partner_invoice_id: res_partner_address_0
+    partner_order_id: res_partner_address_0
+    partner_shipping_id: res_partner_address_0
+    picking_policy: direct
+    pricelist_id: product.list0
+    shop_id: sale.shop
+    priority: normal
+    categ: medical
+    
+    
+- 
+  Creating a sale.order.line record
+- 
+  !record {model: sale.order.line, id: sale_order_line_p0}:
+    company_id: base.main_company
+    delay: 7.0
+    name: P
+    order_id: sale_order_so0
+    order_partner_id: res_partner_a0
+    price_unit: 1.0
+    product_id: product_product_p0
+    product_uom: product.product_uom_unit
+    product_uom_qty: 1.0
+    salesman_id: base.user_admin
+    state: draft
+    th_weight: 0.0
+    type: make_to_stock
+    
+-
+
+  I validate the sale order
+
+-
+  !python {model: sale.order}: |
+    import netsvc
+    wf_service = netsvc.LocalService("workflow")
+    wf_service.trg_validate(uid, 'sale.order', ref("sale_order_so0"), 'order_confirm', cr)
+    
+-
+
+  I check the draft picking creation and create picking object
+
+-
+  !python {model: stock.picking}: |
+    ids = self.search(cr, uid, [('sale_id', '=', ref("sale_order_so0")), ('state', '=', 'draft')], context=context)
+    assert len(ids) == 1, 'number of created draft picking is wrong, 1 - %s'%len(ids)
+    res = self.create_picking(cr, uid, ids, context=context)
+    model = res['res_model']
+    id = res['res_id']
+    # update the context
+    self.pool.get(model).do_create_picking(cr, uid, [id], context=res['context'])
+    
+-
+
+  I check the picking creation, change the flow_type to 'quick' and validate it
+
+-
+  !python {model: stock.picking}: |
+    ids = self.search(cr, uid, [('sale_id', '=', ref("sale_order_so0")), ('state', '=', 'assigned')], context=context)
+    assert len(ids) == 1, 'number of created draft picking is wrong, 1 - %s'%len(ids)
+    # update flow_type
+    self.write(cr, uid, ids, {'flow_type': 'quick',}, context=context)
+    res = self.validate_picking(cr, uid, ids, context=context)
+    model = res['res_model']
+    id = res['res_id']
+    # update the context
+    self.pool.get(model).do_validate_picking(cr, uid, [id], context=res['context'])
+    
+-
+
+  I check the ppl creation, shipment draft and create a new shipment, ship it, validate it, and check
+  that draft shipment is done
+
+-
+  !python {model: shipment}: |
+    ids = self.search(cr, uid, [('state', '=', 'draft'), ('address_id', '=', ref("res_partner_address_0"))], context=context)
+    assert len(ids) == 1, 'number of created draft shipment is wrong, 1 - %s'%len(ids)
+    
+    # create a new shipment
+    res = self.create_shipment(cr, uid, ids, context=context)
+    model = res['res_model']
+    id = res['res_id']
+    # update the context
+    self.pool.get(model).do_create_shipment(cr, uid, [id], context=res['context'])
+    # ship it
+    ids = self.search(cr, uid, [('state', '=', 'packed'), ('address_id', '=', ref("res_partner_address_0"))], context=context)
+    assert len(ids) == 1, 'number of created shipment is wrong, 1 - %s'%len(ids)
+    self.ship(cr, uid, ids, context=context)
+    # validate it
+    self.validate(cr, uid, ids, context=context)
+    # shipment done
+    assert self.browse(cr, uid, ids[0], context=context).state == 'done', 'state is wrong for validated shipment - done - %s'%self.browse(cr, uid, ids[0], context=context).state
+    assert self.browse(cr, uid, ids[0], context=context).backshipment_id.state == 'done', 'state is wrong for draft shipment - done - %s'%self.browse(cr, uid, ids[0], context=context).backshipment_id.state
+    
+-
+
+  I check the ppl creation, shipment draft and create a new shipment, ship it, validate it, and check
+  that draft shipment is done
+
+-
+  !python {model: stock.picking}: |
+    ids = self.search(cr, uid, [('sale_id', '=', ref("sale_order_so0")),], context=context)
+    # we must have 6 objects - draft picking - picking - ppl - draft packing - packing (packed) - packing (shipped)
+    objects = ['draft_picking', 'picking', 'ppl', 'draft_packing', 'packing_packed', 'packing_shipped']
+    assert len(ids) == len(objects), 'the number of picking objects is wrong - %s - %s'%(len(objects), len(ids))
+    assert all([p.state == 'done' for p in self.browse(cr, uid, ids, context=context)]), 'all corresponding picking objects are not done - %s'%[p.state == 'done' for p in self.browse(cr, uid, ids, context=context)]

